import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

public class PPMImageViewer extends JFrame implements ActionListener {

	//this is where the image pixels are drawn
	private JPanel displayPanel;

	//this array holds all the bytes corresponding to the colors of the pixels in the image
	private byte[] imageData;
	
	JFileChooser jfc;

	//default values
	//for each image, these values will be changed
	// after you know the actual dimensions of the image
	private int imageWidth = 800, imageHeight = 800;

	public PPMImageViewer() {

		setSize(800, 800);
		setTitle("PPM Image Viewer 1.0");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		displayPanel = new JPanel();
		displayPanel.setPreferredSize(new Dimension(imageWidth, imageHeight));
		displayPanel.setBackground(Color.PINK);

		Container cp = getContentPane();
		cp.setLayout(new BorderLayout());

		cp.add(displayPanel, BorderLayout.CENTER);
		
		setJMenuBar(buildMenu());

		jfc = new JFileChooser();
		pack();
		setVisible(true);

	}

	public static void main(String[] args) {
		new PPMImageViewer();
	}

	public void paint(Graphics g) {
		super.paint(g);

		displayImage();

	}

	public void displayImage() {
		Graphics g = displayPanel.getGraphics();

		// Complete this method EXACTLY as directed below
		
		// for each pixel in the displayPanel
			// 1. Use the data in the imageData array to determine the
			// appropriate color for the corresponding pixel in the displayPanel
			// 2. Render the pixel in that color
			// by setting the color of the graphics context to that color
			// and then drawing a line of 0 length at that point

	}

	private JMenuBar buildMenu() {
		JMenuBar menuBar = new JMenuBar();
		JMenu fileMenu = new JMenu("File");

		JMenuItem menuItem = new JMenuItem("Open");
		menuItem.addActionListener(this);
		fileMenu.add(menuItem);

		menuItem = new JMenuItem("Exit");
		menuItem.addActionListener(this);

		fileMenu.add(menuItem);

		menuBar.add(fileMenu);
		

		return menuBar;

	}

	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		if (arg0.getActionCommand().equals("Open")) {
			int retVal = jfc.showOpenDialog(null);
			if (retVal == JFileChooser.APPROVE_OPTION) {
				String fileName = jfc.getSelectedFile().getPath();

				readImageData(fileName);
				repaint();
			}
		} else if (arg0.getActionCommand().equals("Exit")) {
			System.exit(0);
		}

	}

	private void readImageData(String ppmFileName) {
		System.out.println("Opening file "+ppmFileName);
			
		imageWidth = readWidth(ppmFileName);
		
		imageHeight = readHeight(ppmFileName);
		
		// Adjust size of displayPanel to these values
		displayPanel.setSize(imageWidth, imageHeight);

		//Adjust size of frame too
		setSize(imageWidth, imageHeight);
		
		//read pixel color information from file into the imageData byte array
		imageData = readPixelBytes(ppmFileName);		
		
	}
	
	// Determine the width of the ppm image
	private int readWidth(String ppmFileName) {
	
	}
	
	// Determine the height of the ppm image
	private int readHeight(String ppmFileName) {
	
	}

	// return a byte array that contains all the image-related bytes from the ppm file
	private byte [] readPixelBytes(String ppmFileName) {
	
	}
}
